// define our rectangular texture samplers
uniform sampler2DRect unit0;
uniform sampler2DRect maskTex;
uniform sampler2DRect unit1;

//
uniform bool    maskIsOn;
uniform float   unit0Alpha;
uniform vec4    unit0AlphaColour;
uniform bool    unit0UseAlphaColour;
uniform bool    unit0IsOn;
uniform bool    unit0IsNegative;
uniform float   unit1Alpha;
uniform vec4    unit1AlphaColour;
uniform bool    unit1UseAlphaColour;
uniform bool    unit1IsOn;
uniform bool    unit1IsNegative;

void main(void)
{
    vec4 result0, result2;
    vec3 eps = vec3(0.01, 0.01, 0.01);
    
    if (maskIsOn && (texture2DRect(maskTex, gl_TexCoord[1].st).r == 0.0)) {
        discard;
    }
    
    result0 = texture2DRect(unit0, gl_TexCoord[0].st);
    
    if (unit0IsNegative) {
        result0.rgb = vec3(1.0, 1.0, 1.0) - result0.rgb;
    }
    
    if (unit0UseAlphaColour
        && all(greaterThanEqual(result0.rgb, unit0AlphaColour.rgb - eps))
        && all(lessThanEqual(result0.rgb, unit0AlphaColour.rgb + eps)))
    {
        result0.a = 0.0;
    }
    
    if (unit1IsOn) {
        result2 = texture2DRect(unit1, gl_TexCoord[2].st);
        result2.a = result2.a * unit1Alpha;
        if (unit1IsNegative) {
            result2.rgb = vec3(1.0, 1.0, 1.0) - result2.rgb;
        }
        if (unit1UseAlphaColour && all(greaterThanEqual(result2.rgb, unit1AlphaColour.rgb-eps)) && all(lessThanEqual(result2.rgb, unit1AlphaColour.rgb + eps))) {
            result2.a = 0.0;
            //result2.a = unit1AlphaColour.rgb == result2.rgb ? 0.0 : result2.a;
        }
        result0 = mix(result0, result2, result2.a);
    }
    gl_FragColor = result0;
}